
/*******************************************************************************
*
* File queries.h
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Query descriptions
*
*******************************************************************************/

#define QUERIES_H

#if (defined FLAGS_C)

static int (*query_fcts[QUERIES])(void)={NULL};


static int QueryUAllocated(void)
{
   return (lat.u>0);
}

static int QueryUdAllocated(void)
{
   return (lat.ud>0);
}

static int QueryBcFlipped(void)
{
   return lat.bc;
}

static int QueryBcdFlipped(void)
{
   return lat.bcd;
}

static int QueryUbufUp2date(void)
{
   return ((lat.u==lat.ubuf)&&(lat.bc==lat.bcbuf));
}

static int QueryUdbufUp2date(void)
{
   return ((lat.udbuf==lat.ud)&&(lat.bcdbuf==lat.bcd));
}

static int QuerySwdUp2date(void)
{
   return ((lat.ud>0)&&(lat.swd[0]==lat.ud));
}

static int QuerySwdEInverted(void)
{
   return (lat.swd[1]==1);
}

static int QuerySwdOInverted(void)
{
   return (lat.swd[2]==1);
}

static void set_queries(void)
{
   query_fcts[U_ALLOCATED]=QueryUAllocated;
   query_fcts[UD_ALLOCATED]=QueryUdAllocated;
   query_fcts[BC_FLIPPED]=QueryBcFlipped;
   query_fcts[BCD_FLIPPED]=QueryBcdFlipped;
   query_fcts[UBUF_UP2DATE]=QueryUbufUp2date;
   query_fcts[UDBUF_UP2DATE]=QueryUdbufUp2date;
   query_fcts[SWD_UP2DATE]=QuerySwdUp2date;
   query_fcts[SWD_E_INVERTED]=QuerySwdEInverted;
   query_fcts[SWD_O_INVERTED]=QuerySwdOInverted;
}

#endif
