
/*******************************************************************************
*
* File linalg.h
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef LINALG_H
#define LINALG_H

#ifndef SU3_H
#include "su3.h"
#endif

#ifndef LINALG_C
extern complex spinor_prod(int vol,int icom,spinor *pk,spinor *pl);
extern float spinor_prod_re(int vol,int icom,spinor *pk,spinor *pl);
extern float norm_square(int vol,int icom,spinor *pk);
extern void mulc_spinor_add(int vol,spinor *pk,spinor *pl,complex z);
extern void project(int vol,int icom,spinor *pk,spinor *pl);
extern float normalize(int vol,int icom,spinor *pk);
extern void rotate(int vol,int n,spinor **ppk,complex v[]);
extern void mulg5(int vol,spinor *pk);
extern void mulmg5(int vol,spinor *pk);
#endif

#ifndef LINALG_DBLE_C
extern complex_dble spinor_prod_dble(int vol,int icom,spinor_dble *pk,
                                     spinor_dble *pl);
extern double spinor_prod_re_dble(int vol,int icom,spinor_dble *pk,
                                  spinor_dble *pl);
extern double norm_square_dble(int vol,int icom,spinor_dble *pk);
extern void mulc_spinor_add_dble(int vol,spinor_dble *pk,spinor_dble *pl,
                                 complex_dble z);
extern void project_dble(int vol,int icom,spinor_dble *pk,spinor_dble *pl);
extern double normalize_dble(int vol,int icom,spinor_dble *pk);
extern void rotate_dble(int vol,int n,spinor_dble **ppk,complex_dble v[]);
extern void mulg5_dble(int vol,spinor_dble *pk);
extern void mulmg5_dble(int vol,spinor_dble *pk);
#endif

#endif
